この記事では、前回の記事で作成したAngularアプリケーションを元にして、WijmoのInputNumber(数値入力)コンポーネントでデータ連結を設定する方法を紹介します。
Wijmoコンポーネントは、Angularのデータ連結をサポートします。Angularには、3種類のデータ連結方法が存在します。
- プロパティ連結:一方向のデータ連結とも呼ばれます。親コンポーネント(この記事ではメインページ)で設定した値が子コンポーネント(この記事ではInputNumberコンポーネント)に渡されます。
- 双方向のデータ連結:親コンポーネントで設定した値が子コンポーネントに渡され、同時に、子コンポーネントで設定した値が親コンポーネントに渡され、親子のコンポーネントの値が同期されます。
- イベント連結:子コンポーネントで特定の操作を行ったときにイベント処理を実行します。

InputNumberコンポーネントの追加
src/app/app.modules.tsファイルで、WjInputModuleモジュールをインポートします。
import { WjInputModule } from 'wijmo/wijmo.angular2.input'; @NgModule({ : imports: [ : WjInputModule ] })
src/app/app.component.htmlファイルで、InputNumberコンポーネントを追加します。
<wj-input-number></wj-input-number>
プロパティ連結
src/app/app.component.htmlファイルで、InputNumberのstepプロパティにデータ連結を設定します。
<wj-input-number [step]="step"></wj-input-number>
src/app/app.component.tsファイルで、連結するプロパティと値を設定します。
export class AppComponent { step: number; constructor() { this.step = 100; } }
アプリケーションを実行すると、stepプロパティが設定され、+ボタンや−ボタンをクリックして値を100単位で変更できることを確認できます。

双方向のデータ連結
src/app/app.component.htmlファイルで、InputNumberのtextプロパティに双方向のデータ連結を設定します。また、テキストボックスを追加して、同様に双方向のデータ連結を設定します。
<wj-input-number ... [(text)]="text"></wj-input-number> <br><input [(ngModel)]="text">
src/app/app.component.tsファイルで、連結するプロパティと値を設定します。
export class AppComponent { text: string; constructor() { this.text = '0'; } }
アプリケーションを実行して、InputNumberまたはテキストボックスで値を変更すると、もう一方の値も同時に変更されることを確認できます。

イベント連結
InputNumberのvalueChangedイベント処理を定義して、値が変更されたときに値の判定処理を行います。
src/app/app.component.tsファイルで、イベント処理を行うonValueChangedメソッドと、値が負数かどうかを示すnegativeプロパティを定義します。また、InputNumberのクラスやメンバーを参照するために、wijmo/wijmo.inputモジュールをインポートします。
import * as wjcInput from 'wijmo/wijmo.input'; export class AppComponent { negative: boolean; constructor() { this.negative = false; } onValueChanged(s: wjcInput.InputNumber) { this.negative = s.value < 0; } }
wijmo/wijmo.inputモジュールをインポートすると、モジュールの型定義ファイルもインポートされ、モジュールのクラスやメンバを記述する際にインテリセンス(自動補完)が有効になります。
src/app/app.component.htmlファイルで、valueChangedのイベント連結を設定します。イベントハンドラメソッドの引数には、コンポーネント変数inputNumberを渡します。また、負数が入力されたことを示す文字列を追加します。
<wj-input-number ... #inputNumber (valueChanged)="onValueChanged(inputNumber)"></wj-input-number> <p *ngIf="negative">負数が入力されました。</p>
ここでは省略していますが、イベントハンドラメソッドの引数にイベント変数
$eventを渡すことも可能です。
アプリケーションを実行すると、負数を入力したときだけ「負数が入力されました。」というメッセージが表示されることが確認できます。

さいごに
製品サイトでは、Wijmoの機能を手軽に体験できるデモアプリケーションやトライアル版も公開しておりますので、こちらもご確認ください。
また、ご導入前の製品に関するご相談、ご導入後の各種サービスに関するご質問など、お気軽にお問合せください。


※2019年2月時点における最新の技術と弊社製品で更新した内容はこちらです。
Reactでは、Create React Appという公式のコマンドラインツールを使用することで、非常に簡単にReactアプリケーションを作成することが可能です。
また、WijmoはReactをサポートしており、Reactの標準的な方法で、グリッド/入力/チャートなどのエンタープライズ向けの高度なUIコンポーネントを利用することができます。
この記事では、Create React AppとWijmoを使用して、日付入力コントロールでデータ連結とイベント処理を行うReactアプリケーションを作成する方法を紹介します。React開発する際のサンプルやチュートリアルとしてご活用ください。
この記事では、次のバージョンのライブラリを使用して動作確認を行っています。
- React 16.0.0
- Create React App v1.4.3
- Node.js 8.9.1

Reactアプリケーションを作成する
まだCreate React Appがインストールされていない場合は、次のコマンドを実行して、Create React Appパッケージをグローバルにインストールします。
npm install -g create-react-app
create-react-appコマンドを実行して、Reactアプリケーションを作成します。少し待つと、アプリケーションのソースファイルや設定ファイルが自動生成され、パッケージがインストールされます。
create-react-app quickstart
アプリケーションの作成が終了したら、アプリケーションのフォルダに移動します。
cd quickstart
Wijmoコンポーネントを追加する
次のコマンドを実行して、Wijmoパッケージをプロジェクトにインストールします。Wijmo製品版を使用する場合は、製品版のNpmImagesフォルダを参照します。
# トライアル版の場合 npm install --save http://prerelease.componentone.com/wijmo5/npm-images/C1Wijmo-Enterprise-Eval-AMD-5.20172.359.tgz # 製品版の場合 npm install --save xxx/NpmImages/wijmo-amd-min/
CDNまたはWijmo製品版から下記の2つのファイルを取得して、プロジェクトのsrcフォルダに追加します。
src/App.jsファイルの先頭で、WijmoのCSSファイル、カルチャーファイル、Inputモジュールをインポートします。
import './wijmo.min.css'; import './wijmo.culture.ja.min.js'; import * as wjInput from 'wijmo/wijmo.react.input';
src/App.jsファイルのAppクラスで、日付値を保持するためのdate変数をStateに追加します。また、日付値が変更されたときに実行されるイベントハンドラを追加します。イベントハンドラでは、アラート画面を表示してから変更された値をStateに設定します。
class App extends Component { constructor(props) { super(props); this.state = { date: new Date(2017, 0, 1), }; this.valueChanged= this.valueChanged.bind(this); } valueChanged(s, e) { alert(s.value.toLocaleDateString() + 'に変更されました。'); this.setState({date: s.value}); } }
src/App.jsファイルのApp.render()メソッドで、InputDateコンポーネントと選択された値を描画します。InputDateコンポーネントでは、valueプロパティに値を連結して、valueChangedイベントハンドラを設定します。
render() { return ( <div> <wjInput.InputDate value={this.state.date} valueChanged={this.valueChanged}></wjInput.InputDate> <p>選択された値: {this.state.date.toLocaleDateString()}</p> </div> ); }
webpackの設定を変更する
Wijmoのカルチャーファイル(wijmo.culture.ja.min.js)を読み込むと、Wijmoコンポーネントをそのカルチャーの言語や書式で表示することができます。ただし、カルチャーファイルはモジュール形式ではないため、webpackのscript-loaderを使用してファイルを読み込む必要があります。
カルチャーファイルを読み込まない場合、このセクションの手順を行う必要はありません。
まず、script-loaderパッケージをインストールします。
npm install --save-dev script-loader
Create React Appで作成したアプリケーションでwebpackの設定を変更するために、npmのejectコマンドを実行します。
npm run eject
config/webpack.config.dev.jsファイルとconfig/webpack.config.prod.jsファイルに次のコードを追加して、script-loaderでカルチャーファイルを読み込めるようにします。
module: { strictExportPresence: true, rules: [ // ==== ここから ==== { test: /wijmo\.culture/, use: [ 'script-loader' ] }, // ==== ここまで ====
アプリケーションを実行する
以上の手順で、クイックスタートアプリケーションの作成は完了です。npm startコマンドを実行すると、Reactアプリケーションが実行されて、日付入力コンポーネントが表示されます。また、日付を変更すると、アラート画面が表示されて連結データが変更されることを確認できます。
npm start

さいごに
製品サイトでは、Wijmoの機能を手軽に体験できるデモアプリケーションやトライアル版も公開しておりますので、こちらもご確認ください。
また、ご導入前の製品に関するご相談、ご導入後の各種サービスに関するご質問など、お気軽にお問合せください。
